<?php //
//$t = 120;
//ini_set("max_execution_time", $t);
set_time_limit(120); // Script timeout in seconds, need some high value for LibreOffice etc
include("engine.php");
if ($EnableUTF8) {
	header('Content-Type: application/json; charset=utf-8');
}

////$jdata = json_decode(file_get_contents('php://input'), true); // JSON data, parse into $jdata array, can check by print_r($jdata)
$gdata = $_GET; // Parameters

$ret["status"] = ""; // status, true on success, false on failure/ error
$ret["Action"] = $gdata["Action"]; // returns the Action/ Action code, same as request
$ret["data"] = ""; // contains payload/ return data
$ret["message"] = ""; // contains error message, if any

$jdata = json_decode(file_get_contents('php://input'), true); // JSON data, parse into $jdata array, can check by print_r($jdata)

if ($EnableUTF8) {
	$jdata = deutf8ize($jdata);
}

/*if (isset($_GET["wsid"])) {
	$wsid = $_GET["wsid"];
}
if (isset($jdata["wsid"])) {
	$wsid = $jdata["wsid"];
}*/

if ($gdata["Action"] == "GetUploadDirectory") {
	$id = intval($jdata["id"]);
	$code = trim($jdata["code"]);
	$updirname = $Nowprecise;

	// Get information from database based on $id
	$info = [];
	$info["id"] = 0;
	$info["name"] = "";
	$info["email"] = "";
	$info["offEmail"] = "";
	$info["phone"] = "";
	$info["postzip"] = "";
	$info["code"] = "";
	$info["registration"] = "";
	$info["lastLogin"] = "";
	$info["count"] = "";
	$info["enabled"] = false;

	$found = false;

	/*	URL called, set c_count+1  and update lastLogin */
	try {
		$conn = DBOpenConnection();
		$sql = "SELECT * FROM canvas WHERE id = :id AND c_code = BINARY :code"; // AND c_enabled = 1";
		$stmt = $conn->prepare($sql);
		$stmt->bindValue(':id', $id, PDO::PARAM_INT);
		$stmt->bindValue(':code', $code, PDO::PARAM_STR);

		$stmt->execute(); // true or false
		$stmt->setFetchMode(PDO::FETCH_ASSOC); // true or false

		$res = $stmt->fetchAll();

		if (count($res) > 0) {
			$info["id"] = intval($res[0]["id"]);
			$info["name"] = $res[0]["c_name"];
			$info["email"] = $res[0]["c_email"];
			$info["offEmail"] = $res[0]["c_2email"];
			if (strlen(trim($info["offEmail"])) == 0) {
				$info["offEmail"] = "";
			}
			$info["phone"] = $res[0]["c_phone"];
			$info["postzip"] = $res[0]["c_zip"];
			$info["code"] = $res[0]["c_code"];
			$info["registration"] = $res[0]["c_registr"];
			$info["lastLogin"] = $res[0]["lastLogin"];
			$info["count"] = intval($res[0]["c_count"]) + 1;
			$info["enabled"] = intval($res[0]["c_enabled"]);

			$found = true;
		}

		if ($info["enabled"] == true)
		{
			$sql = "UPDATE canvas SET c_count = :count, lastLogin = '$Nowed' WHERE id = :id";
			$stmt = $conn->prepare($sql);
			$stmt->bindValue(':id', $id, PDO::PARAM_INT);
			$stmt->bindValue(':count', $info["count"], PDO::PARAM_INT);
			$stmt->execute(); // true or false

			$uploaddir = join(DIRECTORY_SEPARATOR, array($uploadlocation, $updirname)); //uploadloclation unused at the moment. Upload is done manally by admin
			$uploaddircomplete = join(DIRECTORY_SEPARATOR, array(getcwd(), $uploaddir));
			$i = 0;
			while (is_dir(join(DIRECTORY_SEPARATOR, array(getcwd(), $uploaddir)))) {
				$r = rand(1, 10000);
				$dd = new DateTime();
				$Nowpreciseupdated = $dd->format("Y-m-d_Hisu"); // $Nowpreciseupdated = $dd->format("YmdHisu");
				$updirname = $Nowpreciseupdated . $i . $r;
				$uploaddir = join(DIRECTORY_SEPARATOR, array($uploadlocation, $updirname));
				$uploaddircomplete = join(DIRECTORY_SEPARATOR, array(getcwd(), $uploaddir));
				$i = $i + 1;
				if ($i > 100) {
					// timeout? ... // exit;
				}
			}
			$rr = mkdir($uploaddircomplete);
		}
		// if $info["count"] == 1 , then first call with correct code! Send email with gratulations and complete URLs (URLs with code: ...&code=g4De)
		// send_email_first_user_call_canvas();  <<<=== Jay, your turn!  see canvas_functions.php , line 273
	}
	catch(PDOException $e) {
		$ret["status"] = false;
		$ret["message"] = $e->getMessage();
	}
	$conn = null;


	// Find templates in ("uploads/$id" directory)	?? -> in images/users/$id !
	$usertemplates = join(DIRECTORY_SEPARATOR, array(getcwd(), $imagesusers, $id));
	$templates = [];
	if (file_exists($usertemplates)) {
		$files = scandir($usertemplates);
		foreach($files as $file) {
			$filecomplete = join(DIRECTORY_SEPARATOR, array(getcwd(), $uploadlocation, $id, $file));
			if (!is_dir($file)) {
				// Extract extension
				$exp = explode(".", $file);
				$ext = end($exp);
				// is image?
				//	if (in_array($ext, $imgextensions)) {	 // commented out, ekkard: all files should be shown
					array_push($templates, $file);
				//}   commented out, ekkard
			}
		}
	}
	$rdata["Templates"] = $templates;
	$rdata["Info"] = $info;

	// Placeholder common output files...

	if ($info["enabled"] == true) {
		if ($rr) {
			$rdata["Directory"] = str_replace("\\", "/", $uploaddir);
			$ret["status"] = true; // status, true on success, false on failure/ error
			$ret["data"] = $rdata; // contains payload/ return data
			$ret["message"] = "mkdir(\"" . $uploaddir . "\"); successful. Work directory for this session is: <strong>" . $uploaddir . "</strong>"; // contains error message, if any
		} else {
			$ret["status"] = false; // status, true on success, false on failure/ error
			$ret["data"] = ""; // contains payload/ return data
			$ret["message"] = "Unable to mkdir(\"" . $uploaddir . "\"); Please check permissions to <strong>" . $uploadlocation . "</strong> directory."; // contains error message, if any
		}
	} else {
		if ($found == true) {
			$ret["status"] = false; // status, true on success, false on failure/ error
			$ret["data"] = $rdata; // contains payload/ return data
			$ret["message"] = "Your account was disabled. Please address to support: <a href='mailto:egerlach@zeitprax.com?subject=Konto abgelaufen'>egerlach@zeitprax.com</a><br /><br /><a href='javascript:CloseDialog();'>xZxClose</a>"; // contains error message, if any
		} else {
			$ret["status"] = false; // status, true on success, false on failure/ error
			$ret["data"] = $rdata; // contains payload/ return data
			$ret["message"] = "'id' und 'code' xzxdo not match.<br /><br />xzxPlease look in initial email you got for correct id and code or contact support: <a href='mailto:egerlach@zeitprax.com?subject=Fehler beim login, URL'>egerlach@zeitprax.com <= klick!<a><br /><br /><a href='javascript:CloseDialog();'>xZxClose</a>"; // contains error message, if any
		}
	}

	// Directory cleanup code for old working directories for LibreOffice etc
	$dnow = date("YmdHi");
	$dirs = scandir(join(DIRECTORY_SEPARATOR, array(getcwd(), $uploadlocation)));
	foreach($dirs as $dir) {
		$ft = 0;
		$dircomplete = join(DIRECTORY_SEPARATOR, array(getcwd(), $uploadlocation, $dir));

		if ((trim($dir) != ".") && (trim($dir) != "..") && (is_dir($dircomplete)) && (trim($dircomplete) != $uploaddircomplete)) {
			$dircontents = scandir($dircomplete);
			//echo "dir: \t" . $dircomplete . "\n";
			//print_r($dircontents);
			foreach($dircontents as $f) {
				$fcomplete = join(DIRECTORY_SEPARATOR, array(getcwd(), $uploadlocation, $dir, $f));
				if ((trim($f) != ".") && (trim($f) != "..") && (!is_dir($f))) {
					$fd = date("YmdHi", filemtime($fcomplete));
					//echo "fd: \t" . $fd . "\n";
					//echo "ft: \t" . $ft . "\n";
					if ($fd >= $ft) {
						$ft = $fd;
					}
				}
			}
			if (($dnow - $ft) > 100) { // more than 100 minutes old
				//echo "yes \t" . $dir . "\n";
				//echo "Now: \t\t" . $dnow . "\n";
				//echo "Filetime: \t" . $ft . "\n";
				if (DIRECTORY_SEPARATOR == "\\") {
					$ex = "rmdir /S /Q \"" . trim($dircomplete) . "\"";
				} else {
					$ex = "rm -rf \"" . trim($dircomplete) . "\"";
				}
				//echo $dircomplete . "\n";
				//$r = rmdir(trim($dircomplete));

				//exec($ex, $output, $r);
				$r = removedir(trim($dircomplete));
				if (!($r)) {
					echo "Error removing: " . trim($dircomplete) . "<br />\n";
				}
			}
			//echo $dir . " \t" . $dnow . " \t" . $fd . "\n";
		}
	}
}

if ($gdata["Action"] == "Register") {
	include("SendEmail.php");
	$name = trim($jdata["Name"]);
	$email = trim($jdata["Email"]);
	$phone = trim($jdata["Phone"]);
	$postzip = trim($jdata["PostZIP"]);
	$code = random_str($passwordlength);

	// Get information from database based on $id
	$info = [];
	$info["id"] = 0;
	$info["name"] = "";
	$info["email"] = "";
	$info["phone"] = "";
	$info["code"] = "";
    $info["postzip"] = "";
	$info["registration"] = "";
	$info["lastLogin"] = "";
	$info["count"] = "";
	$info["enabled"] = false;

	$r = false;

	try {
		$conn = DBOpenConnection();

		//$stmt = $conn->prepare("INSERT INTO canvas (c_name, c_email, phone, c_zip, c_code, c_registr, lastLogin, c_count, c_enabled) VALUES (:name, :email, :phone, :postzip, :code, '$Nowed', '$Nowed', 0, 1)");
        $stmt = $conn->prepare("INSERT INTO canvas (c_name, c_email, c_phone, c_zip, c_code, c_trial14, c_registr, lastLogin, c_count, c_enabled) VALUES (:name, :email, :phone, :postzip, :code, $TrialPeriod, '$Nowed', '$Nowed', 0, 1)");
		$stmt->bindValue(':name', $name, PDO::PARAM_STR);
		$stmt->bindValue(':email', $email, PDO::PARAM_STR);
		$stmt->bindValue(':phone', $phone, PDO::PARAM_STR);
   		$stmt->bindValue(':postzip', $postzip, PDO::PARAM_INT);
		$stmt->bindValue(':code', $code, PDO::PARAM_STR);
		$r = $stmt->execute(); // true or false

		if ($r) {
			//$sql = "SELECT * FROM canvas WHERE c_name = :name AND c_email = :email AND phone = :phone AND c_zip = :postzip AND c_code = :code AND c_registr = '$Nowed' AND c_enabled = 1";
   			$sql = "SELECT * FROM canvas WHERE c_name = :name AND c_email = :email AND c_phone = :phone AND c_zip = :postzip AND c_code = :code AND c_registr = '$Nowed' AND c_enabled = 1";
			$stmt = $conn->prepare($sql);
			$stmt->bindValue(':name', $name, PDO::PARAM_STR);
			$stmt->bindValue(':email', $email, PDO::PARAM_STR);
			$stmt->bindValue(':phone', $phone, PDO::PARAM_STR);
			$stmt->bindValue(':postzip', $postzip, PDO::PARAM_INT);
			$stmt->bindValue(':code', $code, PDO::PARAM_STR);

			$stmt->execute(); // true or false
			$stmt->setFetchMode(PDO::FETCH_ASSOC); // true or false

			$res = $stmt->fetchAll();

			if (count($res) > 0) {
				$info["id"] = intval($res[0]["id"]);
				$info["name"] = $res[0]["c_name"];
				$info["email"] = $res[0]["c_email"];
				$info["phone"] = $res[0]["phone"];
  				$info["postzip"] = $res[0]["c_zip"];
  				$info["code"] = $res[0]["c_code"];
				$code = $res[0]["c_code"];
				$info["registration"] = $res[0]["c_registr"];
				$info["lastLogin"] = $res[0]["lastLogin"];
				$info["count"] = intval($res[0]["c_count"]);
				$info["enabled"] = intval($res[0]["c_enabled"]);

				// Copy templates to user images
				$dirpath = join(DIRECTORY_SEPARATOR, array(getcwd(), $imagesusers, $info["id"]));
				if (!file_exists($dirpath)) {
					mkdir($dirpath);
					// Copy images to users
					$templateslocationcomplete = join(DIRECTORY_SEPARATOR, array(getcwd(), $templateslocation));
					$templates = [];
					if ((file_exists($dirpath)) && (file_exists($templateslocationcomplete))) {
						$files = scandir($templateslocationcomplete);
						foreach($files as $file) {
							$filecomplete = join(DIRECTORY_SEPARATOR, array(getcwd(), $templateslocation, $file));
							if (!is_dir($file)) {
								// Extract extension
								$exp = explode(".", $file);
								$ext = end($exp);
								$filedestinationcomplete = join(DIRECTORY_SEPARATOR, array(getcwd(), $imagesusers, $info["id"], $file));
								// is image?
								if (in_array($ext, $imgextensions)) {
									copy($filecomplete, $filedestinationcomplete);
								}
							}
						}
					}
				}
				// Send email confirmation
				$Subject = "xzxCanvas registration";
				$Message = "xzxSomebody with your email address demanded a code: <strong>" . $code . "</strong><br /><br />
xzxIf you didn't order this code, then excuse me and ignore this email.<br /><br />
<strong>Eckard Gerlach</strong><br />
egerlach@zeitprax.com <br />P.S. Fragen? Einfach ein Reply auf diese E-Mail, dann ist auch der Code mit dabei.";

				$contact = [];
				$contact[0] = [];
				$contact [0]["Name"] = $info["name"];
				$contact [0]["EMail"] = $info["email"];

				$Ccemail = "egerlach@zeitprax.com";
				$sf = SendEmail($contact, $Ccemail, $Subject, $Message, false, "");
				if ($sf[0] === true) {
					$r = true;
				} else {
					$r = false;
					$ret["message"] = "The email system returned error code: <strong>" . $sf[1] . "</strong>.<br /><strong>Description: </strong>" . $sf[2]; // contains error message, if any
				}
			/*} elseif (count($res) > 1) {
				$ret["status"] = false;
				$ret["message"] = "More than one entry found with same 'id'.";*/
			} else {
				$r = false;
				$ret["message"] = "Record insertion verification failed when retrieving 'id'.";
			}
		}
		else {
			$r = false;
			$ret["message"] = "\$stmt->execute() returned false";
		}
	}
	catch(PDOException $e) {
		$ret["status"] = false;
		$ret["message"] = $e->getMessage();
	}
	$conn = null;


	$rdata["info"] = $info;

	// Placeholder common output files...
	if ($r) {
		$ret["status"] = true; // status, true on success, false on failure/ error
		$ret["data"] = $rdata; // contains payload/ return data
		$ret["message"] = 'xzxRegistration successful. Please note the code sent to your email address: <strong>' . $info["email"] . '<br /><br />';
	} else {
		$ret["status"] = false; // status, true on success, false on failure/ error
		$ret["data"] = ""; // contains payload/ return data
		$ret["message"] = "Registration failed.<br /><strong>Error:</strong><br /><br />" . $ret["message"]; // contains error message, if any
	}
}



if ($gdata["Action"] == "SaveCanvasToPDF") {
	// User validation header code - Begin ValidUser()
	$id = intval($jdata["id"]);
	$code = trim($jdata["code"]);
	$VUser = ValidateUser($id, $code);
	if ($VUser["status"] != true) {
		$ret = $VUser; // error/ invalid
	} else {
		// Protected code

		$data = substr($jdata['imageData'], strpos($jdata['imageData'], ",") + 1);
		$decodedData = base64_decode($data);

		$uploaddir = str_replace("/", DIRECTORY_SEPARATOR, $jdata["Directory"]);
		$uploaddircomplete = join(DIRECTORY_SEPARATOR, array(getcwd(), $uploaddir));
		$file_upload = join(DIRECTORY_SEPARATOR, array(getcwd(), $uploaddir, "pDok.png"));
		$fp = fopen($file_upload, 'wb');
		fwrite($fp, $decodedData);
		fclose($fp);



		$LOprofilepath = join(DIRECTORY_SEPARATOR, array($uploaddircomplete, "LibreOffice" . $Nowprecise));
		$i = 0;
		while (is_dir($LOprofilepath)) {
			$r = rand(1, 10000);
			$dd = new DateTime();
			$Nowpreciseupdated = $dd->format("Y-m-d_Hisu"); // $Nowpreciseupdated = $dd->format("YmdHisu");
			$i = $i + 1;
			$LOprofiledir = "LibreOffice" . $Nowpreciseupdated . $i . $r;
			//$LOprofilepath = str_replace("\\", "/", $LOprofilerootpath). "/" . $LOprofiledir;
			$LOprofilepath = join(DIRECTORY_SEPARATOR, array($uploaddircomplete, $LOprofiledir));
			if ($i > 100) {
				//exit;
			}
		}
		mkdir($LOprofilepath);
		$LOprofilepath1 = $LOprofilepath . "1";
		mkdir($LOprofilepath1);
		$LOprofilepath = str_replace("\\", "/", $LOprofilepath);
		$LOprofilepath1 = str_replace("\\", "/", $LOprofilepath1);

		//if(in_array($file_ext, $extensions) === true) {
			//echo sys_get_temp_dir();
			$LOhomedir = join(DIRECTORY_SEPARATOR, array($uploaddircomplete, $LOhome));
			if (!is_dir($LOhomedir)) {
				mkdir($LOhomedir);
			}
			putenv("HOME=" . $LOhomedir); // could change to getcwd() . $uploadlocation
			//if ($file_ext != "pdf") {
				$LOcomm = "--headless \"-env:UserInstallation=file:///" . $LOprofilepath . "\" --writer --convert-to pdf:writer_pdf_Export --outdir \"" . $uploaddircomplete . "\" \"" . $file_upload . "\"";// 2>&1";

				$ex = $LObinarypath . " $LOcomm 2>&1";
				//echo ".......";
				exec($ex, $output, $r);
				//echo ">>> " . $ex . "</br>\n";
				//print_r($output);
				//echo "<br />\n\n<br />";
				//echo ">>>" . $ex . "\n\n";
				//echo "Return code: " . $r . "\n";
				if ($r) {
					echo $ex . "\n";
					print_r($output);
					echo "Return code: " . $r . "\n";
				}
			//}
			$file_upload = join(DIRECTORY_SEPARATOR, array(getcwd(), $uploaddir, "pDok.pdf"));
			$rdata["PDF"] = "pDok.pdf";
			$rdata["url"] = $uploaddir . "/pDok.pdf";
			$ret["status"] = true; // status, true on success, false on failure/ error
			$ret["data"] = $rdata; // contains payload/ return data
			// Download png is confusing for users:  $ret["message"] = '<a href="' . $uploaddir . '/pDok.png" target="_blank">Download png</a><br /><br /><a href="' . $uploaddir . '/pDok.pdf" target="_blank">Download PDF</a><br />'; // contains error message, if any
			$ret["message"] = '<a href="' . $uploaddir . '/pDok.pdf" target="_blank">Download PDF</a><br />'; // contains error message, if any
		//}


	} // End ValidateUser()
}

if ($gdata["Action"] == "SaveTemplate") {
// User validation header code - Begin ValidUser()
	$id = intval($jdata["id"]);
	$code = trim($jdata["code"]);
	$VUser = ValidateUser($id, $code);
	if ($VUser["status"] != true) {
		$ret = $VUser; // error/ invalid
	} else {
		// Protected code
		$file = trim($jdata["Template"]);
		$data = substr($jdata['imageData'], strpos($jdata['imageData'], ",") + 1);
		$decodedData = base64_decode($data);

		if (strlen($file) > 0) {
			$exp = explode(".", $file);
			$ext = end($exp);
			if (strtolower($ext) != "png") {
				if (trim($ext) == "") { // there is a "." at the end of filename without non-space character
					$file_name_noext = ""; // can derive from $exp	by substr from file_name
					if (count($exp) > 1) {
						for ($i=0; $i<(count($exp) - 1); $i++) {
							if (strlen($file_name_noext) > 0) {
								$file_name_noext = trim($file_name_noext) . "." . $exp[$i];
							} else {
								$file_name_noext = $exp[$i];
							}
						}
					} else {
						$file_name_noext = $file;
					}
					$file = str_replace(".", "-", $file);
				}
				$file = $file . ".png";
			}
		} else {
			$file = "template.png";
		}

		$file_upload = join(DIRECTORY_SEPARATOR, array(getcwd(), $imagesusers, $id, $file));
		$fp = fopen($file_upload, 'wb');
		fwrite($fp, $decodedData);
		fclose($fp);

		// Re-find templates in ("uploads/$id" directory)  ?? -> in images/users/$id !
		$usertemplates = join(DIRECTORY_SEPARATOR, array(getcwd(), $imagesusers, $id));
		$templates = [];
		if (file_exists($usertemplates)) {
			$files = scandir($usertemplates);
			foreach($files as $filef) {
				$filecomplete = join(DIRECTORY_SEPARATOR, array(getcwd(), $uploadlocation, $id, $filef));
				if (!is_dir($filef)) {
					// Extract extension
					$exp = explode(".", $filef);
					$ext = end($exp);
					// is image?
					if (in_array($ext, $imgextensions)) {
						array_push($templates, $filef);
					}
				}
			}
			$rdata["Templates"] = $templates;
			$ret["status"] = true; // status, true on success, false on failure/ error
			$ret["data"] = $rdata; // contains payload/ return data
			$ret["message"] = 'xzxFile saved successfuly as:<br /><br /><strong>' . $file . '</strong><br /><br />xzxThe file is now available as re-usable template.<br /><br /><a href="javascript:CloseDialog();">xZxClose</a>'; // contains error message, if any
		} else {
			$rdata["Templates"] = $templates;
			$ret["status"] = false; // status, true on success, false on failure/ error
			$ret["data"] = $rdata; // contains payload/ return data
			$ret["message"] = 'Error saving file.'; // contains error message, if any
		}
		//$ret["message"] .= '<br /><br />Received data:<br /><textarea rows=10 cols=50>' . $jdata["imageData"] . '</textarea><br />Original data:<br /><textarea rows=10 cols=50>' . $data . '</textarea>';


	} // End ValidateUser()
}



if ($gdata["Action"] == "UpdateTemplatesList") {
	// User validation header code - Begin ValidUser()
	$id = intval($jdata["id"]);
	$code = trim($jdata["code"]);
	$VUser = ValidateUser($id, $code);
	if ($VUser["status"] != true) {
		$ret = $VUser; // error/ invalid
	} else {
		// Protected code

		$upoaddir = trim($jdata["Directory"]);

		// Re-find templates in ("uploads/$id" directory)  ?? -> in images/users/$id !
		$usertemplates = join(DIRECTORY_SEPARATOR, array(getcwd(), $imagesusers, $id));
		$templates = [];
		if (file_exists($usertemplates)) {
			$files = scandir($usertemplates);
			foreach($files as $filef) {
				$filecomplete = join(DIRECTORY_SEPARATOR, array(getcwd(), $uploadlocation, $id, $filef));
				if (!is_dir($filef)) {
					// Extract extension
					$exp = explode(".", $filef);
					$ext = end($exp);
					// is image?
					if (in_array($ext, $imgextensions)) {
						array_push($templates, $filef);
					}
				}
			}
			$rdata["Templates"] = $templates;
			$ret["status"] = true; // status, true on success, false on failure/ error
			$ret["data"] = $rdata; // contains payload/ return data
			$ret["message"] = 'xzxTemplates list fetched.'; // contains error message, if any
		} else {
			$rdata["Templates"] = $templates;
			$ret["status"] = false; // status, true on success, false on failure/ error
			$ret["data"] = $rdata; // contains payload/ return data
			$ret["message"] = 'xzxError fetching templates list.'; // contains error message, if any
		}
		//$ret["message"] .= '<br /><br />Received data:<br /><textarea rows=10 cols=50>' . $jdata["imageData"] . '</textarea><br />Original data:<br /><textarea rows=10 cols=50>' . $data . '</textarea>';


	} // End ValidateUser()
}


if ($gdata["Action"] == "DeleteTemplates") {
	// User validation header code - Begin ValidUser()
	$id = intval($jdata["id"]);
	$code = trim($jdata["code"]);
	$VUser = ValidateUser($id, $code);
	if ($VUser["status"] != true) {
		$ret = $VUser; // error/ invalid
	} else {
		// Protected code

		$templates = $jdata["Templates"];
		$rdata["DeletedTemplates"] = $templates;
		$dtemplates = "";
		// Delete templates
		foreach ($templates as $template) {
			$filecomplete = join(DIRECTORY_SEPARATOR, array(getcwd(), $imagesusers, $id, trim($template)));
			if (file_exists($filecomplete)) {
				if (strlen($dtemplates) > 0) {
					$dtemplates .= "<br />";
				}
				$dtemplates .= $template;
				if (DIRECTORY_SEPARATOR == "\\") {
					$ex = "del \"" . trim($filecomplete) . "\"";
				} else {
					$ex = "rm -f \"" . trim($filecomplete) . "\"";
				}
				exec($ex, $output, $r);
				/*if ($r) {
					echo $ex . "\n";
					print_r($output);
					echo "Return code: " . $r . "\n";
				}*/

			}
		}

		$ret["status"] = true; // status, true on success, false on failure/ error
		//$ret["data"] = $rdata; // contains payload/ return data
		$ret["message"] = 'xzxTemplates deleted:<br /><br /><strong>' . $dtemplates . '</strong>'; // contains error message, if any

		// Re-find templates in ("uploads/$id" directory)  ?? -> in images/users/$id !
		$usertemplates = join(DIRECTORY_SEPARATOR, array(getcwd(), $imagesusers, $id));
		$templates = [];
		if (file_exists($usertemplates)) {
			$files = scandir($usertemplates);
			foreach($files as $filef) {
				$filecomplete = join(DIRECTORY_SEPARATOR, array(getcwd(), $uploadlocation, $id, $filef));
				if (!is_dir($filef)) {
					// Extract extension
					$exp = explode(".", $filef);
					$ext = end($exp);
					// is image?
					if (in_array($ext, $imgextensions)) {
						array_push($templates, $filef);
					}
				}
			}
			$rdata["Templates"] = $templates;
			$ret["status"] = true; // status, true on success, false on failure/ error
			$ret["data"] = $rdata; // contains payload/ return data
			//$ret["message"] .= ' xzxTemplates list fetched.'; // contains error message, if any
		} else {
			$rdata["Templates"] = $templates;
			$ret["status"] = false; // status, true on success, false on failure/ error
			$ret["data"] = $rdata; // contains payload/ return data
			$ret["message"] .= ' xzxError fetching updated templates list.'; // contains error message, if any
		}
		//$ret["message"] .= '<br /><br />Received data:<br /><textarea rows=10 cols=50>' . $jdata["imageData"] . '</textarea><br />Original data:<br /><textarea rows=10 cols=50>' . $data . '</textarea>';


	} // End ValidateUser()
}


if ($gdata["Action"] == "VerifyCode") {
	include("SendEmail.php");
	$id = intval($jdata["id"]);
	$code = trim($jdata["code"]);
	// Get information from database based on $id
	$info = [];
	$info["id"] = 0;
	$info["name"] = "";
	$info["email"] = "";
	$info["phone"] = "";
	$info["code"] = "";
    $info["postzip"] = "";
	$info["registration"] = "";
	$info["lastLogin"] = "";
	$info["count"] = "";
	$info["enabled"] = false;

	/*	URL called, set c_count+1  and update lastLogin */
	try {
		$conn = DBOpenConnection();
		$sql = "SELECT * FROM canvas WHERE id = :id AND c_code = BINARY :code AND c_enabled = 1";
		$stmt = $conn->prepare($sql);
		$stmt->bindValue(':id', $id, PDO::PARAM_INT);
		$stmt->bindValue(':code', $code, PDO::PARAM_STR);

		$stmt->execute(); // true or false
		$stmt->setFetchMode(PDO::FETCH_ASSOC); // true or false

		$res = $stmt->fetchAll();

		if (count($res) > 0) {
			$info["id"] = intval($res[0]["id"]);
			$info["name"] = $res[0]["c_name"];
			$info["email"] = $res[0]["c_email"];
			$info["registration"] = $res[0]["c_registr"];
			$info["lastLogin"] = $res[0]["lastLogin"];
			$info["count"] = intval($res[0]["c_count"]) + 1;
			$info["enabled"] = intval($res[0]["c_enabled"]);
		}

		if ($info["enabled"] == true)
		{
			$sql = "UPDATE canvas SET c_count = :count, lastLogin = '$Nowed' WHERE id = :id";
			$stmt = $conn->prepare($sql);
			$stmt->bindValue(':id', $id, PDO::PARAM_INT);
			$stmt->bindValue(':count', $info["count"], PDO::PARAM_INT);
			$stmt->execute(); // true or false
		}
		// if $info["count"] == 1 , then first call with correct code! Send email with gratulations and complete URLs (URLs with code: ...&code=g4De)
		// send_email_first_user_call_canvas();  <<<=== Jay, your turn!  see canvas_functions.php , line 273
	}
	catch(PDOException $e) {
		$ret["status"] = false;
		$ret["message"] = $e->getMessage();
	}
	$conn = null;

	$rdata["Info"] = $info;

	// Placeholder common output files...
	if ($info["id"] > 0) {
		// Send email confirmation
		$Subject = "xzxCanvas URLs tablet and smartphone";
		$Message = '<strong>xzxCongratulations and Welcome</strong><br><br>
	xzxYou inserted the correct code, thats why you get this email.<br><br>
	<strong>xzxHere are two complete URLs for smartphone and tablet/PC:</strong><br>
	1. Tablet / PC : <a href="https://a44.zeitprax.com/canvas/canvas.php?width=770&height=1080&id='.$info["id"].'&code='.$code.'">https://a44.zeitprax.com/canvas/canvas.php?width=770&height=1080&id='.$info["id"].'&code='.$code.'</a><br>
	2. Smartphone <a href="https://a44.zeitprax.com/canvas/canvas.php?width=330&height=540&id='.$info["id"].'&code='.$code.'">https://a44.zeitprax.com/canvas/canvas.php?width=330&height=540&id='.$info["id"].'&code='.$code.'</a><br><br>
	xzxPreserve this email, save the links on your devices. Change width and height if you want.<br><br>
	Wichtig! Sehen Sie sich bitte immer wieder einmal die beiden Videos
           <a href="https://zeitprax.com/tipps-tricks-3fehler-basis-standard">"Tipps&Tricks und die 3 größten Fehler"(Klick!)</a> sowie
           <a href="https://zeitprax.com/tipps-tricks-3fehler-basis-standard#basis">"Was Sie alles mit dem Basis-/Standard-Paket schon machen können"(Klick!)</a> an.
           Die Videos werden auch aktualisiert.<br><br>
	Viel Erfolg!<br>Eckard Gerlach <br><br>Support: egerlach@zeitprax.com (reply auf diese Email), Mobil: 0171-9287307 (Signal, telegram, threema 4TBA7MM), Skype: teletux9 <br><br>
	<small><strong>PS:</strong> xzxHere are same URLs but on emergency server, if main server is off. Attention: works until tomorrow, after replication at midnight:</strong><br>
	1. Tablet / PC : https://tst1.zeitprax.com/canvas/canvas.php?width=770&height=1080&id='.$info["id"].'&code='.$code.'<br>
	2. Smartphone: https://tst1.zeitprax.com/canvas/canvas.php?width=330&height=540&id='.$info["id"].'&code='.$code.'</small>';

		$contact = [];
		$contact[0] = [];
		$contact [0]["Name"] = $info["name"];
		$contact [0]["EMail"] = $info["email"];

		$Ccemail = "egerlach@zeitprax.com";
		$sf = SendEmail($contact, $Ccemail, $Subject, $Message, false, "");
		if ($sf[0] === true) {
			$r = true;
		} else {
			$r = false;
			$ret["message"] = "The email system returned error code: <strong>" . $sf[1] . "</strong>.<br /><strong>Description: </strong>" . $sf[2]; // contains error message, if any
		}
		$ret["status"] = true; // status, true on success, false on failure/ error
		$ret["data"] = $rdata; // contains payload/ return data
		$ret["message"] = "xzxCode correct! You are Welcome! <br />A Email with URLs is sent to You! (ID: " . $info["id"] . ")<br /><br />xzxPlease look in the email and click."; // contains error message, if any
		//$ret["message"] .= "<a href='https://w99.zeitprax.com/canvas/canvas.php?width=770&height=1080&id=" . $info["id"] . "&code=\"" . $info['code'] . "'>Launch</a>";
	} else {
		$ret["status"] = false; // status, true on success, false on failure/ error
		$ret["data"] = $rdata; // contains payload/ return data
		$ret["message"] = "xzxCode incorrect. Please try again.<br /><br /><a href='javascript:DisplayItem(\"\", \"form\");'>xZxBack</a>"; // contains error message, if any
	}
}




if ($gdata["Action"] == "EmailAttachment") {
// User validation header code - Begin ValidUser()
	$id = intval($jdata["id"]);
	$code = trim($jdata["code"]);
	$VUser = ValidateUser($id, $code);
	if ($VUser["status"] != true) {
		$ret = $VUser; // error/ invalid
	} else {
		// Protected code

		include("SendEmail.php");
		$email2 = trim($jdata["offEmail"]);
		//print_r($jdata["info"]);

		// Refetching info and not using the incoming info from frontend
		$info = [];
		$info["id"] = 0;
		$info["name"] = "";
		$info["email"] = "";
		$info["phone"] = "";
		$info["code"] = "";
	    $info["postzip"] = "";
		$info["registration"] = "";
		$info["lastLogin"] = "";
		$info["count"] = "";
		$info["enabled"] = false;

		$Attachments = [];

		if (strlen($email2) > 0) {
			// generate png
			$data = substr($jdata['imageData'], strpos($jdata['imageData'], ",") + 1);
			$decodedData = base64_decode($data);

			$uploaddir = str_replace("/", DIRECTORY_SEPARATOR, $jdata["Directory"]);
			$uploaddircomplete = join(DIRECTORY_SEPARATOR, array(getcwd(), $uploaddir));
			$file_upload = join(DIRECTORY_SEPARATOR, array(getcwd(), $uploaddir, "pDok.png"));
			$fp = fopen($file_upload, 'wb');
			fwrite($fp, $decodedData);
			fclose($fp);
			array_push($Attachments, $file_upload);

			// generate pdf
			$LOprofilepath = join(DIRECTORY_SEPARATOR, array($uploaddircomplete, "LibreOffice" . $Nowprecise));
			$i = 0;
			while (is_dir($LOprofilepath)) {
				$r = rand(1, 10000);
				$dd = new DateTime();
				$Nowpreciseupdated = $dd->format("Y-m-d_Hisu"); // $Nowpreciseupdated = $dd->format("YmdHisu");
				$i = $i + 1;
				$LOprofiledir = "LibreOffice" . $Nowpreciseupdated . $i . $r;
				//$LOprofilepath = str_replace("\\", "/", $LOprofilerootpath). "/" . $LOprofiledir;
				$LOprofilepath = join(DIRECTORY_SEPARATOR, array($uploaddircomplete, $LOprofiledir));
				if ($i > 100) {
					//exit;
				}
			}
			mkdir($LOprofilepath);
			$LOprofilepath1 = $LOprofilepath . "1";
			mkdir($LOprofilepath1);
			$LOprofilepath = str_replace("\\", "/", $LOprofilepath);
			$LOprofilepath1 = str_replace("\\", "/", $LOprofilepath1);

			//if(in_array($file_ext, $extensions) === true) {
				//echo sys_get_temp_dir();
				$LOhomedir = join(DIRECTORY_SEPARATOR, array($uploaddircomplete, $LOhome));
				if (!is_dir($LOhomedir)) {
					mkdir($LOhomedir);
				}
				putenv("HOME=" . $LOhomedir); // could change to getcwd() . $uploadlocation
				//if ($file_ext != "pdf") {
					$LOcomm = "--headless \"-env:UserInstallation=file:///" . $LOprofilepath . "\" --writer --convert-to pdf:writer_pdf_Export --outdir \"" . $uploaddircomplete . "\" \"" . $file_upload . "\"";// 2>&1";

					$ex = $LObinarypath . " $LOcomm 2>&1";
					//echo ".......";
					exec($ex, $output, $r);
					//echo ">>> " . $ex . "</br>\n";
					//print_r($output);
					//echo "<br />\n\n<br />";
					//echo ">>>" . $ex . "\n\n";
					//echo "Return code: " . $r . "\n";
					if ($r) {
						echo $ex . "\n";
						print_r($output);
						echo "Return code: " . $r . "\n";
					}
				//}
				$file_upload = join(DIRECTORY_SEPARATOR, array(getcwd(), $uploaddir, "pDok.pdf"));
				array_push($Attachments, $file_upload);
				$rdata["PDF"] = "pDok.pdf";
				$rdata["url"] = $uploaddir . "/pDok.pdf";
				$ret["status"] = true; // status, true on success, false on failure/ error
				$ret["data"] = $rdata; // contains payload/ return data
				// Download png is confusing for users:  $ret["message"] = '<a href="' . $uploaddir . '/pDok.png" target="_blank">Download png</a><br /><br /><a href="' . $uploaddir . '/pDok.pdf" target="_blank">Download PDF</a><br />'; // contains error message, if any
				//$ret["message"] = '<a href="' . $uploaddir . '/pDok.pdf" target="_blank">Download PDF</a><br />'; // contains error message, if any
			//}
			// end generate pdf

			// Send email
			$Subject = "xzxCanvas documents attached";
			$Message = "xzxAutomatic email with files attached<br /><br />
<strong>Eckard Gerlach</strong><br />
egerlach@zeitprax.com <br />P.S. Fragen? Einfach ein Reply auf diese E-Mail, dann ist auch der Code mit dabei.";

			$contact = [];
			$contact[0] = [];
			$contact [0]["Name"] = "";
			$contact [0]["EMail"] = $email2;

			$Ccemail = "egerlach@zeitprax.com";
			$sf = SendEmail($contact, $Ccemail, $Subject, $Message, true, $Attachments);
			if ($sf[0] === true) {
				$r = true;
			} else {
				$r = false;
				$ret["message"] = "The email system returned error code: <strong>" . $sf[1] . "</strong>.<br /><strong>Description: </strong>" . $sf[2]; // contains error message, if any
				$ret["message"] .= "<br /><br />Error sending email to: <a href=\"mailto:" . $email2 . "\">" . $email2 . "</a>";
			}
		} else {
			$r = false;
			$ret["message"] = "xzxSend png and pdf by email is locked. <br />xzxMake it unlock: <a href=\"https://zeitprax.com/he\">Extra Feature '1x-Klick-Email-Versand'</a><br /><br /><a href='javascript:CloseDialog();'>xZxClose</a>";
		}

		// Placeholder common output files...
		if ($r) {
			$ret["status"] = true; // status, true on success, false on failure/ error
			$ret["data"] = $rdata; // contains payload/ return data
			$ret["message"] = 'xzxEmail successfully sent to: <strong><a href="mailto:' . $email2 . '">' . $email2 . '</a></strong>';
		} else {
			$ret["status"] = false; // status, true on success, false on failure/ error
			$ret["data"] = ""; // contains payload/ return data
			//$ret["message"] = "Registration failed.<br /><strong>Error:</strong><br /><br />" . $ret["message"]; // contains error message, if any
		}


	} // End ValidateUser()
}








if ($EnableUTF8) {
	echo json_encode(utf8ize($ret), JSON_FORCE_OBJECT); // Doesn't encode non-English characters without UTF-8
} else {
	echo json_encode($ret, JSON_FORCE_OBJECT); // Doesn't encode non-English characters without UTF-8
}

// https://stackoverflow.com/questions/19361282/why-would-json-encode-return-an-empty-string
function utf8ize($d) {
	if (is_array($d)) {
		foreach ($d as $k => $v) {
			$d[$k] = utf8ize($v);
		}
	} else if (is_string ($d)) {
		return utf8_encode($d);
	}
	return $d;
}

function deutf8ize($d) {
	if (is_array($d)) {
		foreach ($d as $k => $v) {
			$d[$k] = deutf8ize($v);
		}
	} else if (is_string ($d)) {
		return utf8_decode($d);
	}
	return $d;
}


/**
 * Generate a random string, using a cryptographically secure
 * pseudorandom number generator (random_int)
 *
 * For PHP 7, random_int is a PHP core function
 * For PHP 5.x, depends on https://github.com/paragonie/random_compat
 *
 * @param int $length	   How many characters do we want?
 * @param string $keyspace A string of all possible characters
 *						   to select from
 * @return string
 */
function random_str_old(
	$length,
	$keyspace = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ'
	//`~!@#$%^&*()-_+=\|/?[{}]<,>.
	//!#%&*()-+=?<,>.
) {
	$str = '';
	//$max = mb_strlen($keyspace, '8bit') - 1;
	$max = strlen($keyspace) - 1;
	if ($max < 1) {
		throw new Exception('$keyspace must be at least two characters long');
	}
	for ($i = 0; $i < $length; ++$i) {
		$str .= $keyspace[random_int(0, $max)];
	}
	// aim: update $str that the following is granted: one char of each of these 4 "char-groups": (0..9), (a..z), (A..Z), (!#%&*()-+=?<,>.)
	//	 You can do it so: 1. create 4 different randon mumbers between  0 and $length-1
	//					   2. replace these 4 positions in $str by one randomly found char in these 4 "char-groups"
	//	 Or do you have better idea to reach the aim faster?
	return $str;
}


function random_str(
	$length
) {
	$keys = [];
	$keys[0] = [];
	$keys[0]["keyspace"] = "123456789";   // not use 0 <-> O
	$keys[0]["mincount"] = 1; // how many to include
	$keys[0]["maxcount"] = 1; // how many to include
	$keys[1] = [];
	$keys[1]["keyspace"] = "abcdefghijklmnopqrstuvwxyz";
	$keys[1]["mincount"] = 1; // how many to include
	$keys[1]["maxcount"] = 1; // how many to include
	$keys[2] = [];
	$keys[2]["keyspace"] = "ABCDEFGHIJKLMNPQRSTUVWXYZ"; // not use O <-> 0
	$keys[2]["mincount"] = 1; // how many to include
	$keys[2]["maxcount"] = 1; // how many to include
/*	$keys[3] = [];
	$keys[3]["keyspace"] = "!#%*-+=?,[."; // & ( ) < > ] / \ better not use
	$keys[3]["mincount"] = 1; // how many to include
	$keys[3]["maxcount"] = 1; // how many to include
*/
	$str = '';

	$c = 0;
	while (strlen($str) < $length)
	{
		for ($i = 0; $i < count($keys); ++$i)
		{
			//$max = mb_strlen($keyspace, '8bit') - 1;
			//$max = strlen($keys[$i]["keyspace"]); - 1;
			$max = strlen($keys[$i]["keyspace"]) - 1;
			if ($max < 1) {
				throw new Exception('$keyspace must be at least two characters long');
			}
			$str .= $keys[$i]["keyspace"][random_int(0, $max)];
		}
	}
	$str = substr($str, 0, $length);
	$exp = str_split($str);
	//shuffle($str);
	shuffle($exp);
	$str = implode("", $exp);
	/*for ($i = 0; $i < $length; ++$i) {
		$str .= $keyspace[random_int(0, $max)];
	}*/
	// aim: update $str that the following is granted: one char of each of these 4 "char-groups": (0..9), (a..z), (A..Z), (!#%&*()-+=?<,>.)
	//	 You can do it so: 1. create 4 different randon mumbers between  0 and $length-1
	//					   2. replace these 4 positions in $str by one randomly found char in these 4 "char-groups"
	//	 Or do you have better idea to reach the aim faster?
	return $str;
}


function removedir($dir) {
	//$dir = 'samples' . DIRECTORY_SEPARATOR . 'sampledirtree';
	$it = new RecursiveDirectoryIterator($dir, RecursiveDirectoryIterator::SKIP_DOTS);
	$files = new RecursiveIteratorIterator($it,
				 RecursiveIteratorIterator::CHILD_FIRST);
	foreach($files as $file) {
		if ($file->isDir()){
			rmdir($file->getRealPath());
		} else {
			unlink($file->getRealPath());
		}
	}
	return rmdir($dir);
}


function removedirs($directory) {
	$dirs = scandir($directory);
	foreach($dirs as $dir) {
		$d = join(DIRECTORY_SEPARATOR, array($directory, $dir));
		if ((trim($dir) != ".") && (trim($dir) != "..") && (is_dir(trim($d)))) {
			if (DIRECTORY_SEPARATOR == "\\") {
				$ex = "rmdir /S /Q \"" . trim($d) . "\"";
			} else {
				$ex = "rm -rf \"" . trim($d) . "\"";
			}
			exec($ex, $output, $r);
			/*if ($r) {
				echo $ex . "\n";
				print_r($output);
				echo "Return code: " . $r . "\n";
			}*/
		}
	}
}


// cleans contact number (telephone, fax) from non-numeric characters
function cleancontactnumber($number) {
	$remchars = [" ", "-", "/", ".", ","];
	foreach ($remchars as $ch)
	{
		$number = str_replace($ch, "", $number);
	}
	return $number;
}

function subst_specialchars_filenames($text) {
	$specialchars=array("!","|","#","*","<",">"," ", "'",",", "/", "\\", "\"", "\:","°",".","`","^");
	$ret=str_replace($specialchars,"_",$text);
	return $ret;
	}

function limittext($text, $length) {
	$ret = $text;
	if (strlen($text) > $length)
	{
		$ret = substr($ret, 0, $length);
	}
	return $ret;
}

function mbStringToArray ($string) {
	$strlen = mb_strlen($string);
	while ($strlen) {
		$array[] = mb_substr($string,0,1,"UTF-8");
		$string = mb_substr($string,1,$strlen,"UTF-8");
		$strlen = mb_strlen($string);
	}
	return $array;
}


function extension($file) {
	$exp = explode(".", $file);
	return end($exp);
}

function ValidateUser($id, $code) {
	// Get information from database based on $id
	$info = [];
	$info["id"] = 0;
	$info["name"] = "";
	$info["email"] = "";
	$info["offEmail"] = "";
	$info["phone"] = "";
	$info["postzip"] = "";
	$info["code"] = "";
	$info["registration"] = "";
	$info["lastLogin"] = "";
	$info["count"] = "";
	$info["enabled"] = false;

	$found = false;

	$DBError = false;
	try {
		$conn = DBOpenConnection();
		$sql = "SELECT * FROM canvas WHERE id = :id AND c_code = BINARY :code"; // AND c_enabled = 1";
		$stmt = $conn->prepare($sql);
		$stmt->bindValue(':id', $id, PDO::PARAM_INT);
		$stmt->bindValue(':code', $code, PDO::PARAM_STR);

		$stmt->execute(); // true or false
		$stmt->setFetchMode(PDO::FETCH_ASSOC); // true or false

		$res = $stmt->fetchAll();

		if (count($res) > 0) {
			$info["id"] = intval($res[0]["id"]);
			$info["name"] = $res[0]["c_name"];
			$info["email"] = $res[0]["c_email"];
			$info["offEmail"] = $res[0]["c_2email"];
			if (strlen(trim($info["offEmail"])) == 0) {
				$info["offEmail"] = "";
			}
			$info["phone"] = $res[0]["c_phone"];
			$info["postzip"] = $res[0]["c_zip"];
			$info["code"] = $res[0]["c_code"];
			$info["registration"] = $res[0]["c_registr"];
			$info["lastLogin"] = $res[0]["lastLogin"];
			$info["count"] = intval($res[0]["c_count"]) + 1;
			$info["enabled"] = intval($res[0]["c_enabled"]);

			$found = true;
		}
	}
	catch(PDOException $e) {
		$DBError = true;
		$ret["status"] = false;
		$ret["message"] = $e->getMessage();
	}
	$conn = null;

	$rdata["Info"] = $info;

	if ($info["enabled"] == true) {
		$ret["status"] = true; // status, true on success, false on failure/ error
		$ret["data"] = $rdata; // contains payload/ return data
		$ret["message"] = ""; // contains error message, if any
	} else {
		if ($found == true) {
			$ret["status"] = false; // status, true on success, false on failure/ error
			$ret["data"] = $rdata; // contains payload/ return data
			$ret["message"] = "Your account was disabled. Please address to support: <a href='mailto:egerlach@zeitprax.com?subject=Konto abgelaufen'>egerlach@zeitprax.com</a><br /><br /><a href='javascript:CloseDialog();'>xZxClose</a>"; // contains error message, if any
		} else {
			if ($DBError != true) {
				$ret["status"] = false; // status, true on success, false on failure/ error
				$ret["data"] = $rdata; // contains payload/ return data
				$ret["message"] = "'id' und 'code' xzxdo not match.<br /><br />xzxPlease look in initial email you got for correct id and code or contact support: <a href='mailto:egerlach@zeitprax.com?subject=Fehler beim login, URL'>egerlach@zeitprax.com <= klick!<a><br /><br /><a href='javascript:CloseDialog();'>xZxClose</a>"; // contains error message, if any
			}
		}
	}
	return $ret;
}


?>
